"""init db

Revision ID: 2cad88d938f1
Revises: 
Create Date: 2023-01-15 14:56:29.929937

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "2cad88d938f1"
down_revision = None
branch_labels = None
depends_on = None


def _has_table(name: str) -> bool:
    from sqlalchemy import inspect

    insp = inspect(op.get_bind())
    return name in insp.get_table_names()


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    if _has_table("chatrecorder_message_record"):
        op.rename_table(
            "chatrecorder_message_record", "nonebot_plugin_chatrecorder_messagerecord"
        )
    else:
        op.create_table(
            "nonebot_plugin_chatrecorder_messagerecord",
            sa.Column("id", sa.Integer(), nullable=False),
            sa.Column("platform", sa.String(32), nullable=False),
            sa.Column("time", sa.DateTime(), nullable=False),
            sa.Column("type", sa.String(32), nullable=False),
            sa.Column("detail_type", sa.String(32), nullable=False),
            sa.Column("message_id", sa.String(64), nullable=False),
            sa.Column("message", sa.String(255), nullable=False),
            sa.Column("alt_message", sa.String(255), nullable=False),
            sa.Column("user_id", sa.String(64), nullable=False),
            sa.Column("group_id", sa.String(64), nullable=True),
            sa.PrimaryKeyConstraint("id"),
        )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("nonebot_plugin_chatrecorder_messagerecord")
    # ### end Alembic commands ###
